diff --git a/enrol/authorize/localfuncs.php b/enrol/authorize/localfuncs.php
index 456ec94..cffe4a6 100644
--- a/enrol/authorize/localfuncs.php
+++ b/enrol/authorize/localfuncs.php
@@ -1,18 +1,43 @@
 <?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize enrolment plugin.
+ *
+ * This plugin allows you to set up paid courses, using authorize.net.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
 
 require_once($CFG->libdir.'/eventslib.php');
 
-function get_course_cost($course)
-{
-    global $CFG;
+function get_course_cost($plugininstance) {
+    $defaultplugin = enrol_get_plugin('authorize');
 
     $cost = (float)0;
-    $currency = (!empty($course->currency))
-                 ? $course->currency :( empty($CFG->enrol_currency)
-                                        ? 'USD' : $CFG->enrol_currency );
+    $currency = (!empty($plugininstance->currency))
+                 ? $plugininstance->currency :( empty($defaultplugin->currency)
+                                        ? 'USD' : $defaultplugin->enrol_currency );
 
-    if (!empty($course->cost)) {
-        $cost = (float)(((float)$course->cost) < 0) ? $CFG->enrol_cost : $course->cost;
+    if (!empty($plugininstance->cost)) {
+        $cost = (float)(((float)$plugininstance->cost) < 0) ? $defaultplugin->cost : $plugininstance->cost;
     }
 
     $cost = format_float($cost, 2);
@@ -24,26 +49,26 @@ function get_course_cost($course)
     return $ret;
 }
 
-function zero_cost($course) {
-    $curcost = get_course_cost($course);
+function zero_cost($plugininstance) {
+    $curcost = get_course_cost($plugininstance);
     return (abs($curcost['cost']) < 0.01);
 }
 
-function prevent_double_paid($course)
-{
+function prevent_double_paid($plugininstance) {
     global $CFG, $SESSION, $USER, $DB;
+    $plugin = enrol_get_plugin('authorize');
 
-    $sql = "SELECT id FROM {enrol_authorize} WHERE userid = ? AND courseid = ? ";
-    $params = array($USER->id, $course->id);
+    $sql = "SELECT id FROM {enrol_authorize} WHERE userid = ? AND courseid = ? AND instanceid = ?";
+    $params = array($USER->id, $plugininstance->courseid, $plugininstance->id);
 
-    if (empty($CFG->an_test)) { // Real mode
-        $sql .= 'AND status IN(?,?,?)';
+    if (!$plugin->get_config('an_test')) { // Real mode
+        $sql .= ' AND status IN(?,?,?)';
         $params[] = AN_STATUS_AUTH;
         $params[] = AN_STATUS_UNDERREVIEW;
         $params[] = AN_STATUS_APPROVEDREVIEW;
     }
     else { // Test mode
-        $sql .= 'AND status=?';
+        $sql .= ' AND status=?';
         $params[] = AN_STATUS_NONE;
     }
 
@@ -61,9 +86,8 @@ function prevent_double_paid($course)
     }
 }
 
-function get_list_of_creditcards($getall = false)
-{
-    global $CFG;
+function get_list_of_creditcards($getall = false) {
+    $plugin = enrol_get_plugin('authorize');
 
     $alltypes = array(
         'mcd' => 'Master Card',
@@ -77,44 +101,61 @@ function get_list_of_creditcards($getall = false)
         'enr' => 'EnRoute'
     );
 
-    if ($getall or empty($CFG->an_acceptccs)) {
+    if ($getall) {
         return $alltypes;
     }
 
     $ret = array();
-    $ccs = explode(',', $CFG->an_acceptccs);
-    foreach ($ccs as $key) {
-        $ret[$key] = $alltypes[$key];
+    foreach ($alltypes as $code=>$name) {
+        if ($plugin->get_config("an_acceptcc_{$code}")) {
+            $ret[$code] = $name;
+        }
     }
+
     return $ret;
 }
 
-function get_list_of_payment_methods($getall = false)
-{
-    global $CFG;
+function get_list_of_payment_methods($getall = false) {
+    $plugin = enrol_get_plugin('authorize');
+    $method_cc = $plugin->get_config('an_acceptmethod_cc');
+    $method_echeck = $plugin->get_config('an_acceptmethod_echeck');
+
 
-    if ($getall || empty($CFG->an_acceptmethods)) {
+    if ($getall || (empty($method_cc) && empty($method_echeck))) {
         return array(AN_METHOD_CC, AN_METHOD_ECHECK);
-    }
-    else {
-        return explode(',', $CFG->an_acceptmethods);
+    } else {
+        $methods = array();
+        if ($method_cc) {
+            $methods[] = AN_METHOD_CC;
+        }
+
+        if ($method_echeck) {
+            $methods[] = AN_METHOD_ECHECK;
+        }
+
+        return $methods;
     }
 }
 
-function get_list_of_bank_account_types($getall = false)
-{
-    global $CFG;
+function get_list_of_bank_account_types($getall = false) {
+    $plugin = enrol_get_plugin('authorize');
+    $alltypes = array('CHECKING', 'BUSINESSCHECKING', 'SAVINGS');
 
-    if ($getall || empty($CFG->an_acceptechecktypes)) {
-        return array('CHECKING', 'BUSINESSCHECKING', 'SAVINGS');
-    }
-    else {
-        return explode(',', $CFG->an_acceptechecktypes);
+    if ($getall) {
+        return $alltypes;
+    } else {
+        $types = array();
+        foreach ($alltypes as $type) {
+            if ($plugin->get_config("an_acceptecheck_{$type}")) {
+                $types[] = $type;
+            }
+        }
+
+        return $types;
     }
 }
 
-function message_to_admin($subject, $data)
-{
+function message_to_admin($subject, $data) {
     global $SITE;
 
     $admin = get_admin();
@@ -124,6 +165,8 @@ function message_to_admin($subject, $data)
     $emailmessage .= print_r($data, true);
     $eventdata = new object();
     $eventdata->modulename        = 'moodle';
+    $eventdata->component         = 'enrol_authorize';
+    $eventdata->name              = 'authorize_enrolment';
     $eventdata->userfrom          = $admin;
     $eventdata->userto            = $admin;
     $eventdata->subject           = "$SITE->fullname: Authorize.net ERROR";
@@ -134,8 +177,7 @@ function message_to_admin($subject, $data)
     message_send($eventdata);
 }
 
-function send_welcome_messages($orderdata)
-{
+function send_welcome_messages($orderdata) {
     global $CFG, $SITE, $DB;
 
     if (empty($orderdata)) {
@@ -191,6 +233,8 @@ function send_welcome_messages($orderdata)
 
                 $eventdata = new object();
                 $eventdata->modulename        = 'moodle';
+                $eventdata->component         = 'enrol_authorize';
+                $eventdata->name              = 'authorize_enrolment';
                 $eventdata->userfrom          = $sender;
                 $eventdata->userto            = $user;
                 $eventdata->subject           = get_string("enrolmentnew", '', $SITE->shortname);
@@ -207,20 +251,20 @@ function send_welcome_messages($orderdata)
     }
 }
 
-function check_curl_available()
-{
+function check_curl_available() {
     return function_exists('curl_init') &&
            function_exists('stream_get_wrappers') &&
            in_array('https', stream_get_wrappers());
 }
 
-function authorize_verify_account()
-{
-    global $CFG, $USER, $SITE;
+function authorize_verify_account() {
+    global $USER, $SITE;
+    $plugin = enrol_get_plugin('authorize');
+
     require_once('authorizenet.class.php');
 
-    $original_antest = $CFG->an_test;
-    $CFG->an_test = 1; // Test mode
+    $original_antest = $plugin->get_config('an_test');
+    $plugin->set_config('an_test', 1); // Test mode
 
     $order = new stdClass();
     $order->id = -1;
@@ -257,7 +301,9 @@ function authorize_verify_account()
     else {
         $ret = get_string('verifyaccountresult', 'enrol_authorize', $message);
     }
-    $CFG->an_test = $original_antest;
+
+    $plugin->set_config('an_test', $original_antest);
+
     return $ret;
 }
 
diff --git a/enrol/authorize/locallib.php b/enrol/authorize/locallib.php
index 9e010ce..4a3a0bd 100644
--- a/enrol/authorize/locallib.php
+++ b/enrol/authorize/locallib.php
@@ -1,4 +1,30 @@
 <?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize enrolment plugin.
+ *
+ * This plugin allows you to set up paid courses, using authorize.net.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
 
 if (!defined('MOODLE_INTERNAL')) {
     die('Direct access to this script is forbidden.');
@@ -17,6 +43,9 @@ function authorize_print_orders($courseid, $userid) {
     global $course;
     global $CFG, $USER, $SITE, $DB, $OUTPUT, $PAGE;
     global $strs, $authstrs;
+
+    $plugin = enrol_get_plugin('authorize');
+
     require_once($CFG->libdir.'/tablelib.php');
 
     $perpage = optional_param('perpage', 10, PARAM_INT);
@@ -132,7 +161,7 @@ function authorize_print_orders($courseid, $userid) {
         switch ($status)
         {
             case AN_STATUS_NONE:
-                if (empty($CFG->an_test)) {
+                if (!$plugin->get_config('an_test')) {
                     $where .= "AND (e.status != :status) ";
                     $params['status'] = AN_STATUS_NONE;
                 }
@@ -223,6 +252,9 @@ function authorize_print_order($orderid)
     global $CFG, $USER, $DB, $OUTPUT, $PAGE;
     global $strs, $authstrs;
 
+    $plugin = enrol_get_plugin('authorize');
+    $an_test = $plugin->get_config('an_test');
+
     $do = optional_param('do', '', PARAM_ALPHA);
     $unenrol = optional_param('unenrol', 0, PARAM_BOOL);
     $confirm = optional_param('confirm', 0, PARAM_BOOL);
@@ -269,6 +301,7 @@ function authorize_print_order($orderid)
     }
     $PAGE->navbar->add($authstrs->paymentmanagement, 'index.php?course='.$course->id);
     $PAGE->navbar->add($authstrs->orderid . ': ' . $orderid, 'index.php');
+    $PAGE->set_course($course);
     $PAGE->set_title("$course->shortname: $authstrs->paymentmanagement");
     $PAGE->set_heading($authstrs->orderdetails);
     $PAGE->set_cacheable(false);
@@ -302,9 +335,9 @@ function authorize_print_order($orderid)
             $message = '';
             $extra = NULL;
             if (AN_APPROVED == AuthorizeNet::process($order, $message, $extra, AN_ACTION_PRIOR_AUTH_CAPTURE)) {
-                if (empty($CFG->an_test)) {
+                if (empty($an_test)) {
                     if (enrol_into_course($course, $user, 'authorize')) {
-                        if (!empty($CFG->enrol_mailstudents)) {
+                        if ($plugin->get_config('enrol_mailstudents')) {
                             send_welcome_messages($orderid);
                         }
                         redirect("$CFG->wwwroot/enrol/authorize/index.php?order=$orderid");
@@ -352,13 +385,15 @@ function authorize_print_order($orderid)
             $message = '';
             $success = AuthorizeNet::process($order, $message, $extra, AN_ACTION_CREDIT);
             if (AN_APPROVED == $success || AN_REVIEW == $success) {
-                if (empty($CFG->an_test)) {
+                if (empty($an_test)) {
                     if (empty($extra->id)) {
                         redirect("$CFG->wwwroot/enrol/authorize/index.php?order=$orderid", "insert record error", 20);
                     }
                     else {
                         if (!empty($unenrol)) {
-                            role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
+                            $pinstance = $DB->get_record('enrol', array('id'=>$order->instanceid));
+                            $plugin->unenrol_user($pinstance, $order->userid);
+                            //role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
                         }
                         redirect("$CFG->wwwroot/enrol/authorize/index.php?order=$orderid");
                     }
@@ -383,7 +418,9 @@ function authorize_print_order($orderid)
     elseif (ORDER_DELETE == $do && in_array(ORDER_DELETE, $statusandactions->actions)) {
         if ($confirm && confirm_sesskey()) {
             if (!empty($unenrol)) {
-                role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
+                $pinstance = $DB->get_record('enrol', array('id'=>$order->instanceid));
+                $plugin->unenrol_user($pinstance, $order->userid);
+                //role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
             }
             $DB->delete_records('enrol_authorize', array('id'=>$orderid));
             redirect("$CFG->wwwroot/enrol/authorize/index.php");
@@ -399,7 +436,7 @@ function authorize_print_order($orderid)
                 $extra = NULL;
                 $message = '';
                 if (AN_APPROVED == AuthorizeNet::process($order, $message, $extra, AN_ACTION_VOID)) {
-                    if (empty($CFG->an_test)) {
+                    if (empty($an_test)) {
                         redirect("$CFG->wwwroot/enrol/authorize/index.php?order=$orderid");
                     }
                     else {
@@ -434,9 +471,11 @@ function authorize_print_order($orderid)
                     $message = '';
                     $extra = NULL;
                     if (AN_APPROVED == AuthorizeNet::process($suborder, $message, $extra, AN_ACTION_VOID)) {
-                        if (empty($CFG->an_test)) {
+                        if (empty($an_test)) {
                             if (!empty($unenrol)) {
-                                role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
+                                $pinstance = $DB->get_record('enrol', array('id'=>$order->instanceid));
+                                $plugin->unenrol_user($pinstance, $order->userid);
+                                //role_unassign_all(array('userid'=>$order->userid, 'contextid'=>$coursecontext->id, 'component'=>'enrol_authorize'), true, true);
                             }
                             redirect("$CFG->wwwroot/enrol/authorize/index.php?order=$orderid");
                         }
diff --git a/enrol/authorize/settings.php b/enrol/authorize/settings.php
new file mode 100644
index 0000000..fb4356b
--- /dev/null
+++ b/enrol/authorize/settings.php
@@ -0,0 +1,176 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Paypal enrolments plugin settings and presets.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter - based on code by others
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+require_once('localfuncs.php');
+require_once('const.php');
+
+if ($ADMIN->fulltree) {
+    global $CFG, $DB, $OUTPUT;
+    $mconfig = get_config('enrol_authorize');
+
+    // Check curl availability
+    if (!check_curl_available()) {
+        $settings->add(new admin_setting_heading('enrol_authorize_notification', '', 'PHP must be compiled with cURL+SSL support (--with-curl --with-openssl)'));
+        return;
+    }
+
+    // Check https availability
+    if (empty($CFG->loginhttps) and substr($CFG->wwwroot, 0, 5) !== 'https') {
+        $a = new stdClass;
+        $a->url = "$CFG->wwwroot/$CFG->admin/settings.php?section=httpsecurity";
+        $settings->add(new admin_setting_heading('enrol_authorize_notification', '', get_string('adminconfighttps', 'enrol_authorize', $a)));
+        return;
+    } elseif (isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] != 443) { // MDL-9836
+        $wwwsroot = qualified_me();
+        $wwwsroot = str_replace('http:', 'https:', $wwwsroot);
+        $a = new stdClass;
+        $a->url = $wwwsroot;
+        $settings->add(new admin_setting_heading('enrol_authorize_notification', '', get_string('adminconfighttpsgo', 'enrol_authorize', $a)));
+        return;
+    }
+
+    // Account verification notification
+    if (optional_param('verifyaccount', 0, PARAM_INT)) {
+        $settings->add(new admin_setting_heading('enrol_authorize_notification', '', authorize_verify_account()));
+    }
+
+    // Review check
+    if (!empty($mconfig->an_review)) {
+        $captureday = intval($mconfig->an_capture_day);
+        $emailexpired = intval($mconfig->an_emailexpired);
+        if ($captureday > 0 || $emailexpired > 0) {
+            $lastcron = $DB->get_field_sql('SELECT max(lastcron) FROM {modules}');
+            if ((time() - intval($lastcron) > 3600 * 24)) {
+                $settings->add(new admin_setting_heading('enrol_authorize_cron_notification', '', get_string('admincronsetup', 'enrol_authorize')));
+            }
+        }
+    }
+
+    // Pending orders check
+    if (($count = $DB->count_records('enrol_authorize', array('status'=>AN_STATUS_AUTH)))) {
+        $a = new stdClass;
+        $a->count = $count;
+        $a->url = $CFG->wwwroot."/enrol/authorize/index.php?status=".AN_STATUS_AUTH;
+        $settings->add(new admin_setting_heading('enrol_authorize_status_notification', '', get_string('adminpendingorders', 'enrol_authorize', $a)));
+    }
+
+
+    // Set up the form
+
+    $settings->add(new admin_setting_heading('enrol_authorize_settings', '', get_string('description', 'enrol_authorize')));
+
+    //--- sitewide settings ---------------------------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_authorize_sitewide',
+        get_string("adminauthorizewide", "enrol_authorize"), ''));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/cost', get_string('cost', 'enrol_authorize'), '', 5, PARAM_FLOAT, 4));
+
+    $settings->add(new admin_setting_configselect('enrol_authorize/currency', get_string('currency', 'enrol_authorize'), '', 'USD', get_string_manager()->get_list_of_currencies()));
+
+    if (!optional_param('verifyaccount', 0, PARAM_INT) && isset($mconfig->an_login) && (isset($mconfig->an_tran_key) || isset($mconfig->an_password))) {
+
+        $settings->add(new admin_setting_heading('enrol_authorize_verification', '',
+            '<a href="settings.php?section=enrolsettingsauthorize&amp;verifyaccount=1"><b>'.
+            get_string("verifyaccount", "enrol_authorize").'</b></a>'));
+    }
+
+    //--- authorize.net settings ----------------------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_authorize_net_settings',
+        get_string("adminauthorizesettings", "enrol_authorize"), get_string('logininfo', 'enrol_authorize')));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/an_login', get_string('anlogin', 'enrol_authorize'), '', ''));
+
+    $settings->add(new admin_setting_configpasswordunmask('enrol_authorize/an_tran_key', get_string('antrankey', 'enrol_authorize'), '', ''));
+
+    $settings->add(new admin_setting_configpasswordunmask('enrol_authorize/an_password', get_string('anpassword', 'enrol_authorize'), '', ''));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/an_referer', get_string('anreferer', 'enrol_authorize'), get_string('anrefererdesc', 'enrol_authorize'), 'http://'));
+
+    $settings->add(new admin_setting_configtime('enrol_authorize/an_cutoff_hour', 'an_cutoff_min', get_string('cutofftime', 'enrol_authorize'), get_string('cutofftimedesc', 'enrol_authorize'), ''));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_avs', get_string('anavs', 'enrol_authorize'), get_string('anavsdesc', 'enrol_authorize'), 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_authcode', get_string('anauthcode', 'enrol_authorize'), get_string('anauthcodedesc', 'enrol_authorize'), 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_test', get_string('antestmode', 'enrol_authorize'), get_string('antestmodedesc', 'enrol_authorize'), 0));
+
+    $paymentmethods = get_list_of_payment_methods(true);
+    $settings->add(new admin_setting_heading('enrol_authorize_net_payment_method_settings',
+        '', get_string('adminaccepts', 'enrol_authorize')));
+    foreach ($paymentmethods as $key) {
+        if ($key == AN_METHOD_CC) {
+            $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_acceptmethod_'.AN_METHOD_CC,
+                                                            get_string('method'.AN_METHOD_CC, 'enrol_authorize'),
+                                                            get_string('method'.AN_METHOD_CC.'desc', 'enrol_authorize'),
+                                                            0));
+            $ccs = get_list_of_creditcards(true);
+            foreach ($ccs as $key => $val) {
+                $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_acceptcc_'.$key,
+                                                                $val,
+                                                                '', 0));
+            }
+        } elseif ($key == AN_METHOD_ECHECK) {
+            $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_acceptmethod_'.AN_METHOD_ECHECK,
+                                                            get_string('method'.AN_METHOD_ECHECK, 'enrol_authorize'),
+                                                            get_string('method'.AN_METHOD_ECHECK.'desc', 'enrol_authorize'),
+                                                            0));
+            $echecktypes = get_list_of_bank_account_types(true);
+            foreach ($echecktypes as $value) {
+                $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_acceptecheck_'.$value,
+                                                                $value,
+                                                                '', 0));
+            }
+        }
+    }
+
+    //--- order review and capture settings -----------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_authorize_capture',
+        get_string("adminauthorizeccapture", "enrol_authorize"), ''));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/an_review', get_string('anreview', 'enrol_authorize'), get_string('anreviewdesc', 'enrol_authorize'), 0));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/an_capture_day', get_string('ancaptureday', 'enrol_authorize'), get_string('ancapturedaydesc', 'enrol_authorize'), 5, PARAM_INT, 4));
+
+
+    //--- email sending settings ----------------------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_authorize_email',
+        get_string("adminauthorizeemail", "enrol_authorize"), ''));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/an_emailexpired', get_string('anemailexpired', 'enrol_authorize'), get_string('anemailexpireddesc', 'enrol_authorize'), 5, PARAM_INT, 4));
+
+    $settings->add(new admin_setting_configtext('enrol_authorize/an_emailexpiredteacher', get_string('anemailexpiredteacher', 'enrol_authorize'), get_string('anemailexpiredteacherdesc', 'enrol_authorize'), 5, PARAM_INT, 4));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/mailstudents', get_string('mailstudents'), '', 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/mailteachers', get_string('mailteachers'), '', 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_authorize/mailadmin', get_string('mailadmins'), '', 0));
+
+}
diff --git a/enrol/authorize/unenrolself.php b/enrol/authorize/unenrolself.php
new file mode 100644
index 0000000..2333bd9
--- /dev/null
+++ b/enrol/authorize/unenrolself.php
@@ -0,0 +1,64 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize.Net enrolment plugin - support for user self unenrolment.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require('../../config.php');
+
+$enrolid = required_param('enrolid', PARAM_INT);
+$confirm = optional_param('confirm', 0, PARAM_BOOL);
+
+$instance = $DB->get_record('enrol', array('id'=>$enrolid, 'enrol'=>'authorize'), '*', MUST_EXIST);
+$course = $DB->get_record('course', array('id'=>$instance->courseid), '*', MUST_EXIST);
+$context = get_context_instance(CONTEXT_COURSE, $course->id, MUST_EXIST);
+
+require_login();
+if (!is_enrolled($context)) {
+    redirect(new moodle_url('/'));
+}
+require_login($course);
+
+$plugin = enrol_get_plugin('authorize');
+
+// security defined inside following function
+if (!$plugin->get_unenrolself_link($instance)) {
+    redirect(new moodle_url('/course/view.php', array('id'=>$course->id)));
+}
+
+$PAGE->set_url('/enrol/authorize/unenrolself.php', array('enrolid'=>$instance->id));
+$PAGE->set_title($plugin->get_instance_name($instance));
+
+if ($confirm and confirm_sesskey()) {
+    $plugin->unenrol_user($instance, $USER->id);
+    add_to_log($course->id, 'course', 'unenrol', '../enrol/users.php?id='.$course->id, $course->id); //there should be userid somewhere!
+    redirect(new moodle_url('/index.php'));
+}
+
+echo $OUTPUT->header();
+$yesurl = new moodle_url($PAGE->url, array('confirm'=>1, 'sesskey'=>sesskey()));
+$nourl = new moodle_url('/course/view.php', array('id'=>$course->id));
+$message = get_string('unenrolselfconfirm', 'enrol_authorize', format_string($course->fullname));
+echo $OUTPUT->confirm($message, $yesurl, $nourl);
+echo $OUTPUT->footer();
diff --git a/enrol/authorize/uploadcsv.php b/enrol/authorize/uploadcsv.php
index 11da31f..3f4b4f2 100644
--- a/enrol/authorize/uploadcsv.php
+++ b/enrol/authorize/uploadcsv.php
@@ -1,5 +1,4 @@
 <?php
-
 // This file is part of Moodle - http://moodle.org/
 //
 // Moodle is free software: you can redistribute it and/or modify
@@ -15,6 +14,16 @@
 // You should have received a copy of the GNU General Public License
 // along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 
+/**
+ * Authorize.Net enrolment plugin - support for user self unenrolment.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
 /// Load libraries
 require_once('../../config.php');
 require_once($CFG->dirroot.'/enrol/authorize/const.php');
@@ -62,6 +71,8 @@ echo $OUTPUT->footer();
 function authorize_process_csv($filename) {
     global $CFG, $SITE, $DB;
 
+    $plugin = enrol_get_plugin('authorize');
+
     /// We need these fields
     $myfields = array(
         'Transaction ID',           // enrol_authorize.transid or enrol_authorize_refunds.transid; See: Reference Transaction ID
@@ -214,15 +225,13 @@ function authorize_process_csv($filename) {
                     $timestart = time();
                     $timeend = $timestart + $course->enrolperiod;
                 }
-                //TODO: do some real enrolment here
-                if (role_assign($role->id, $user->id, $coursecontext->id, 'enrol_authorize')) {
-                    $imported++;
-                    if (!empty($CFG->enrol_mailstudents)) {
-                        $sendem[] = $order->id;
-                    }
-                }
-                else {
-                    $ignoredlines .= $transid . ": Error while trying to enrol " . fullname($user) . " in '$course->fullname' \n";
+                // Enrol user
+                $pinstance = $DB->get_record('enrol', array('id'=>$order->instanceid));
+                $plugin->enrol_user($pinstance, $user->id, $pinstance->roleid, $timestart, $timeend);
+
+                $imported++;
+                if ($plugin->get_config('enrol_mailstudents')) {
+                    $sendem[] = $order->id;
                 }
             }
         }
@@ -235,6 +244,8 @@ function authorize_process_csv($filename) {
 
         $eventdata = new object();
         $eventdata->modulename        = 'moodle';
+        $eventdata->component         = 'enrol_authorize';
+        $eventdata->name              = 'authorize_enrolment';
         $eventdata->userfrom          = $admin;
         $eventdata->userto            = $admin;
         $eventdata->subject           = "$SITE->fullname: Authorize.net CSV ERROR LOG";
